diff --git a/tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php b/tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php
new file mode 100644
index 0000000..eaea694
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php
@@ -0,0 +1,238 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Auth;
+
+use Auth;
+use DB;
+use Settings;
+use Socialite;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Laravel\Socialite\Contracts\User as SocialUserContract;
+use Mockery as m;
+
+class SocialAuthControllerTest extends FunctionalTestCase
+{
+    public function test_social_login_for_new_user()
+    {
+        $this->setSettings(['reg_enabled' => true]);
+
+        $socialUser = new StubSocialUser;
+
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        $this->visit("auth/foo/callback");
+
+        $this->assertUserCreatedAndLoggedIn($socialUser, 'foo');
+    }
+
+    public function test_social_login_for_new_user_if_registration_is_disabled()
+    {
+        Settings::set('reg_enabled', false);
+
+        $socialUser = new StubSocialUser;
+
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        $this->visit("auth/foo/callback");
+
+        $this->seePageIs('login')
+            ->see('Only users who already created an account can log in.');
+    }
+
+    public function test_social_login_for_banned_user()
+    {
+        $user = factory(User::class)->create(['status' => UserStatus::BANNED]);
+        $socialUser = new StubSocialUser;
+
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        DB::table('social_logins')->insert([
+            'user_id' => $user->id,
+            'provider' => 'foo',
+            'provider_id' => $socialUser->getId(),
+            'avatar' => $socialUser->getAvatar(),
+            'created_at' => \Carbon\Carbon::now()
+        ]);
+
+        $this->visit("auth/foo/callback");
+
+        $this->seePageIs('/login')
+            ->see(trans('app.your_account_is_banned'));
+    }
+
+    public function test_social_login_for_existing_user()
+    {
+        $user = factory(User::class)->create();
+        $socialUser = new StubSocialUser;
+
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        DB::table('social_logins')->insert([
+            'user_id' => $user->id,
+            'provider' => 'foo',
+            'provider_id' => $socialUser->getId(),
+            'avatar' => $socialUser->getAvatar(),
+            'created_at' => \Carbon\Carbon::now()
+        ]);
+
+        $this->visit("auth/foo/callback");
+
+        $this->seePageIs('/');
+        $this->assertEquals($user->id, Auth::id());
+    }
+
+    public function test_twitter_login()
+    {
+        $this->setSettings(['reg_enabled' => true]);
+
+        $socialUser = new StubSocialUserWithoutEmail;
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+        Socialite::shouldReceive('driver')->with('twitter')->andReturn($driver);
+
+        $this->visit("auth/twitter/callback")
+            ->seePageIs('auth/twitter/email')
+            ->seeInSession('social.user', $socialUser);
+
+        $socialUser->email = 'john@doe.com';
+
+        $this->type('john@doe.com', 'email')
+            ->press('Log Me In')
+            ->assertUserCreatedAndLoggedIn($socialUser, 'twitter');
+    }
+
+    public function test_missing_email_for_non_twitter_provider()
+    {
+        $this->setSettings(['reg_enabled' => true]);
+
+        $socialUser = new StubSocialUserWithoutEmail;
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        $this->visit("auth/foo/callback")
+            ->seePageIs('login')
+            ->see("You have to provide your email address.");
+    }
+
+    public function test_social_login_for_user_with_one_word_name()
+    {
+        $this->setSettings(['reg_enabled' => true]);
+
+        $socialUser = new StubSocialUserWithOneWordName;
+
+        $driver = m::mock(\Laravel\Socialite\Contracts\Provider::class);
+        $driver->shouldReceive('user')->andReturn($socialUser);
+
+        Socialite::shouldReceive('driver')->with('foo')->andReturn($driver);
+
+        $this->visit("auth/foo/callback");
+
+        $this->seeInDatabase('users', [
+            'username'   => null,
+            'email'      => $socialUser->getEmail(),
+            'first_name' => 'John',
+            'last_name'  => '',
+            'status'     => UserStatus::ACTIVE
+        ]);
+
+        $user = User::where('email', $socialUser->getEmail())->first();
+
+        $this->seeInDatabase('social_logins', [
+            'user_id'     => $user->id,
+            'provider'    => 'foo',
+            'provider_id' => $socialUser->getId(),
+            'avatar'      => $socialUser->getAvatar()
+        ]);
+
+        $this->seePageIs('/');
+        $this->assertEquals($user->id, Auth::id());
+    }
+
+    /**
+     * @param $socialUser
+     */
+    private function assertUserCreatedAndLoggedIn($socialUser, $provider)
+    {
+        $this->seeInDatabase('users', [
+            'username'   => null,
+            'email'      => $socialUser->getEmail(),
+            'first_name' => 'John',
+            'last_name'  => 'Doe',
+            'status'     => UserStatus::ACTIVE
+        ]);
+
+        $user = User::where('email', $socialUser->getEmail())->first();
+
+        $this->seeInDatabase('social_logins', [
+            'user_id'     => $user->id,
+            'provider'    => $provider,
+            'provider_id' => $socialUser->getId(),
+            'avatar'      => $socialUser->getAvatar()
+        ]);
+
+        $this->seePageIs('/');
+        $this->assertEquals($user->id, Auth::id());
+    }
+
+}
+
+class StubSocialUser implements SocialUserContract
+{
+    public function getId()
+    {
+        return '123';
+    }
+
+    public function getNickname()
+    {
+        return 'johndoe';
+    }
+
+    public function getName()
+    {
+        return 'John Doe';
+    }
+
+    public function getEmail()
+    {
+        return 'john@doe.com';
+    }
+
+    public function getAvatar()
+    {
+        return 'http://www.gravatar.com/avatar';
+    }
+}
+
+class StubSocialUserWithoutEmail extends StubSocialUser
+{
+    public $email = null;
+
+    public function getEmail()
+    {
+        return $this->email;
+    }
+}
+
+class StubSocialUserWithOneWordName extends StubSocialUser
+{
+    public function getName()
+    {
+        return 'John';
+    }
+}
\ No newline at end of file
diff --git a/tests/Feature/Http/Controllers/PermissionsControllerTest.php b/tests/Feature/Http/Controllers/PermissionsControllerTest.php
new file mode 100644
index 0000000..415bba6
--- /dev/null
+++ b/tests/Feature/Http/Controllers/PermissionsControllerTest.php
@@ -0,0 +1,183 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\Permission\Created;
+use Portal\Events\Permission\Updated;
+use Portal\Events\Role\PermissionsUpdated;
+use Portal\Permission;
+use Portal\Role;
+use Mockery as m;
+
+class PermissionsControllerTest extends FunctionalTestCase
+{
+    protected $user;
+
+    protected $seed = false;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->user = $this->createSuperUser();
+        $this->be($this->user);
+    }
+
+    public function test_permissions_list()
+    {
+        $permission = factory(Permission::class)->create();
+
+        $this->visit('permission')
+            ->seeInTable('table', $permission->display_name, 1, 1);
+
+        $this->assertEquals(1, $this->crawler->filter('table tbody tr')->count());
+        $this->assertEquals(2, $this->crawler->filter('table tbody tr:nth-child(1) > td')->count());
+    }
+
+    public function test_permission_list_with_roles()
+    {
+        $permission = factory(Permission::class)->create();
+        $role = factory(Role::class)->create();
+
+        $role->perms()->attach($permission->id);
+
+        $this->visit('permission')
+            ->seeInTable('table', $permission->display_name, 1, 1)
+            ->seeElement('input', ['type' => 'checkbox', 'name' => "roles[$role->id][]"]);
+
+        $this->assertEquals(1, $this->crawler->filter('table tbody tr')->count());
+        $this->assertEquals(3, $this->crawler->filter('table tbody tr:nth-child(1) > td')->count());
+    }
+
+    public function test_save_role_permissions()
+    {
+        $this->expectsEvents(PermissionsUpdated::class);
+
+        $permission = factory(Permission::class)->create();
+        $role = factory(Role::class)->create();
+
+        $role->perms()->attach($permission->id);
+
+        $this->visit('permission')
+            ->submitForm('Save Permissions', [
+                'roles' => [
+                    $role->id => [$permission->id]
+                ]
+            ]);
+
+        $this->seePageIs('permission')
+            ->see('Permissions saved successfully.')
+            ->seeIsChecked("roles[{$role->id}][]")
+            ->seeInDatabase('permission_role', [
+                'role_id' => $role->id,
+                'permission_id' => $permission->id
+            ]);
+    }
+
+    public function test_save_role_permissions_if_no_permission_is_selected_for_specific_role()
+    {
+        $this->expectsEvents(PermissionsUpdated::class);
+
+        $permission = factory(Permission::class)->create();
+        $permission2 = factory(Permission::class)->create();
+        $role = factory(Role::class)->create();
+        $role2 = factory(Role::class)->create();
+
+        $role->perms()->attach($permission->id);
+        $role2->perms()->attach($permission2->id);
+
+        $this->visit('permission');
+
+        $form = $this->getForm('Save Permissions');
+
+        //Uncheck all checkboxes for Role 2
+        $form['roles'][$role2->id][0]->untick();
+        $form['roles'][$role2->id][1]->untick();
+
+        $this->makeRequestUsingForm($form);
+
+        $this->seePageIs('permission')
+            ->see('Permissions saved successfully.')
+            ->seeInDatabase('permission_role', [
+                'role_id' => $role->id,
+                'permission_id' => $permission->id
+            ])
+            ->dontSeeInDatabase('permission_role', [
+                'role_id' => $role2->id,
+                'permission_id' => $permission2->id
+            ]);
+    }
+
+    public function test_create_permission()
+    {
+        $this->app->instance('middleware.disable', false);
+
+        $this->expectsEvents(Created::class);
+
+        $data = $this->stubPermissionData();
+
+        $this->visit('permission')
+            ->click('Add Permission')
+            ->seePageIs('permission/create')
+            ->submitForm('Create Permission', $data);
+
+        $this->seePageIs('permission')
+            ->see('Permission created successfully.')
+            ->seeInDatabase('permissions', $data);
+    }
+
+    public function test_update_permission()
+    {
+        $this->expectsEvents(Updated::class);
+
+        $permission = factory(Permission::class)->create();
+
+        $data = $this->stubPermissionData();
+
+        $this->visit('permission')
+            ->clickOn('a[title="Edit Permission"]')
+            ->seePageIs("permission/{$permission->id}/edit")
+            ->submitForm('Update Permission', $data);
+
+        $this->seePageIs('permission')
+            ->see('Permission updated successfully.')
+            ->seeInDatabase('permissions', $data + ['id' => $permission->id]);
+    }
+
+    public function test_delete()
+    {
+        $this->expectsEvents(\Portal\Events\Permission\Deleted::class);
+
+        $permission = factory(Permission::class)->create();
+
+        $this->delete(route('permission.destroy', $permission->id))
+            ->followRedirects();
+
+        $this->seePageIs('permission')
+            ->see('Permission deleted successfully.')
+            ->dontSeeInDatabase('permissions', ['id' => $permission->id]);
+
+    }
+
+    public function test_if_non_removable_permissions_can_be_removed()
+    {
+        $permission = factory(Permission::class)->create(['removable' => false]);
+
+        $this->visit('permission');
+        $this->assertEquals(0, $this->crawler->filter("a[title='Delete Permission']")->first()->count());
+
+        $this->delete(route('permission.destroy', $permission->id))
+            ->followRedirects();
+
+        $this->assertResponseStatus(404);
+    }
+
+    private function stubPermissionData()
+    {
+        return [
+            'name' => 'foo_permission',
+            'display_name' => 'Foo Permission',
+            'description' => 'the description'
+        ];
+    }
+}
diff --git a/tests/Feature/Http/Controllers/ProfileControllerTest.php b/tests/Feature/Http/Controllers/ProfileControllerTest.php
new file mode 100644
index 0000000..c02cf7b
--- /dev/null
+++ b/tests/Feature/Http/Controllers/ProfileControllerTest.php
@@ -0,0 +1,326 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Authy;
+use Hash;
+use Input;
+use Settings;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\User\ChangedAvatar;
+use Portal\Events\User\UpdatedProfileDetails;
+use Portal\Role;
+use Portal\Support\Enum\UserStatus;
+use Carbon\Carbon;
+
+class ProfileControllerTest extends FunctionalTestCase
+{
+    protected $user;
+
+    public function setUp()
+    {
+        parent::setUp();
+
+        $this->user = $this->createAndLoginUser();
+    }
+
+    public function test_can_access_profile_page()
+    {
+        $this->visit('/')
+            ->click('My Profile')
+            ->seePageIs('profile');
+    }
+
+    public function test_update_details()
+    {
+        $this->expectsEvents(UpdatedProfileDetails::class);
+
+        $data = $this->getStubDetailsData();
+
+        $this->visit('profile')
+            ->submitForm('Update Details', $data)
+            ->seePageIs('profile')
+            ->see('Profile updated successfully.')
+            ->seeInDatabase('users', $data + ['id' => $this->user->id]);
+    }
+
+    public function test_cannot_change_role_or_status()
+    {
+        $data = $this->getStubDetailsData();
+
+        $extendedData = $data + [
+            'role' => Role::whereName('Admin')->first()->id,
+            'status' => UserStatus::BANNED,
+        ];
+
+        $this->visit('profile')
+            ->submitForm('Update Details', $extendedData)
+            ->seePageIs('profile')
+            ->see('Profile updated successfully.')
+            ->seeInDatabase('users', $data + ['id' => $this->user->id, 'status' => UserStatus::ACTIVE])
+            ->dontSeeInDatabase('role_user', [
+                'user_id' => $this->user->id,
+                'role_id' => $extendedData['role']
+            ]);
+    }
+
+    public function test_update_avatar()
+    {
+        $this->expectsEvents(ChangedAvatar::class);
+
+        $uploads = ['avatar' => base_path('tests/files/image.png')];
+
+        $input = [
+            'points' => [
+                'x1' => 0,
+                'y1' => 0,
+                'x2' => 200,
+                'y2' => 200
+            ]
+        ] + $uploads;
+
+        $this->visit("profile")
+            ->submitForm('Save', $input, $uploads)
+            ->seePageIs('profile')
+            ->see('Avatar changed successfully.');
+
+        $user = $this->user->fresh();
+
+        $uploadedFile = public_path("upload/users/{$user->avatar}");
+
+        $this->assertNotNull($user->avatar);
+        $this->assertFileExists($uploadedFile);
+
+        list($width, $height) = getimagesize($uploadedFile);
+
+        $this->assertEquals(160, $width);
+        $this->assertEquals(160, $height);
+
+        @unlink($uploadedFile);
+    }
+
+    public function test_update_avatar_with_invalid_image_file()
+    {
+        $file = storage_path("app/portal-test.php");
+
+        file_put_contents($file, "<?php ");
+
+        $uploads = ['avatar' => $file];
+
+        $input = [
+            'points' => [
+                'x1' => 0,
+                'y1' => 0,
+                'x2' => 200,
+                'y2' => 200
+            ]
+        ] + $uploads;
+
+        $this->visit("profile")
+            ->submitForm('Save', $input, $uploads)
+            ->seePageIs('profile')
+            ->see("The avatar must be an image.");
+
+        $user = $this->user->fresh();
+
+        $this->assertNull($user->avatar);
+
+        @unlink($file);
+    }
+
+    public function test_update_avatar_external()
+    {
+        $this->expectsEvents(ChangedAvatar::class);
+
+        $data = ['url' => '//www.gravatar.com/avatar'];
+        $this->post(route('profile.update.avatar-external', $this->user->id), $data)
+            ->followRedirects()
+            ->seePageIs('profile')
+            ->see('Avatar changed successfully.');
+
+        $this->seeInDatabase('users', ['id' => $this->user->id, 'avatar' => $data['url']]);
+    }
+
+    public function test_update_social_networks()
+    {
+        $data = [
+            'facebook' => 'facebook',
+            'twitter' => 'twitter',
+            'google_plus' => 'g+',
+            'linked_in' => 'li',
+            'dribbble' => 'Dribble',
+            'skype' => 'skyyype'
+        ];
+
+        $this->visit("profile")
+            ->submitForm('Update Social Networks', ['socials' => $data])
+            ->seeInDatabase('user_social_networks', $data)
+            ->seePageIs("profile")
+            ->see("Social networks updated successfully.");
+    }
+
+    public function test_update_user_login_details()
+    {
+        $data = [
+            'email' => 'john@doe.com',
+            'username' => 'milos',
+            'password' => 'milos123123',
+            'password_confirmation' => 'milos123123'
+        ];
+
+        $this->visit("profile")
+            ->submitForm("update-login-details-btn", $data)
+            ->seePageIs("profile")
+            ->see('Login details updated successfully.');
+
+        $user = $this->user->fresh();
+
+        $this->assertEquals($data['email'], $user->email);
+        $this->assertEquals($data['username'], $user->username);
+        $this->assertTrue(Hash::check($data['password'], $user->password));
+    }
+
+    public function test_password_is_not_changed_if_omitted_on_update()
+    {
+        $this->user = $this->createAndLoginUser([
+            'email' => 'john@doe.com',
+            'password' => '123123'
+        ]);
+
+        $data = ['email' => 'test@test.com', 'password' => '', 'password_confirmation' => ''];
+
+        $this->visit("profile")
+            ->submitForm("update-login-details-btn", $data)
+            ->seePageIs("profile")
+            ->see('Login details updated successfully.');
+
+        $user = $this->user->fresh();
+
+        $this->assertEquals($data['email'], $user->email);
+        $this->assertTrue(Hash::check('123123', $user->password));
+    }
+
+    public function test_2fa_form_visibility()
+    {
+        Settings::set('2fa.enabled', false);
+
+        $this->visit("profile")
+            ->dontSee('Two-Factor Authentication');
+
+        Settings::set('2fa.enabled', true);
+
+        $this->visit("profile")
+            ->see('Two-Factor Authentication');
+    }
+
+    public function test_enable_2fa()
+    {
+        $this->expectsEvents(\Portal\Events\User\TwoFactorEnabled::class);
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+
+        $this->visit("profile")
+            ->submitForm('Enable', $data)
+            ->seePageIs("profile")
+            ->seeInDatabase('users', [
+                'id' => $this->user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ])
+            ->see('Two-Factor Authentication enabled successfully.');
+    }
+
+    public function test_disable_2fa()
+    {
+        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabled::class);
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->visit("profile")
+            ->press('Disable')
+            ->seePageIs("profile")
+            ->seeInDatabase('users', [
+                'id' => $this->user->id,
+                'two_factor_country_code' => null,
+                'two_factor_phone' => null
+            ])
+            ->see('Two-Factor Authentication disabled successfully.');
+    }
+
+    public function test_activity_log()
+    {
+        $logger = app(\Portal\Services\Logging\UserActivity\Logger::class);
+
+        Carbon::setTestNow(Carbon::now());
+
+        $logger->log('foo');
+        $logger->log('bar');
+
+        $buttonSelector = "a[data-content='".Input::header('User-agent')."']";
+
+        $this->visit('profile/activity')
+            ->seeInTable('table', Input::ip(), 1, 1)
+            ->seeInTable('table', 'foo', 1, 2)
+            ->seeInTable('table', Carbon::now()->toDateTimeString(), 1, 3)
+            ->seeElement("table tbody tr:nth-child(1) > td:nth-child(4) > {$buttonSelector}")
+            ->seeInTable('table', Input::ip(), 2, 1)
+            ->seeInTable('table', 'bar', 2, 2)
+            ->seeInTable('table', Carbon::now()->toDateTimeString(), 2, 3)
+            ->seeElement("table tbody tr:nth-child(2) > td:nth-child(4) > {$buttonSelector}");
+    }
+
+    public function test_session_invalidation()
+    {
+        putenv('SESSION_DRIVER=database');
+
+        $this->refreshApplication();
+
+        if ($this->isSQLiteConnection()) {
+            $this->executeCallbacks();
+        }
+
+        Carbon::setTestNow(Carbon::now());
+
+        $user = $this->createAndLoginAdminUser();
+
+        $this->visit('user')
+            ->click('Active Sessions')
+            ->seePageIs("profile/sessions")
+            ->seeInTable('table', Input::ip(), 1, 1)
+            ->seeInTable('table', Input::header("User-agent"), 1, 2)
+            ->seeInTable('table', Carbon::now()->toDateString(), 1, 3);
+
+        $this->assertEquals(1, $this->crawler->filter("table tbody tr")->count());
+
+        $url = $this->crawler->filter('a[title="Invalidate Session"]')->first()->link()->getUri();
+
+        $this->delete($url)
+            ->followRedirects()
+            ->dontSeeInDatabase('sessions', ['user_id' => $user->id]);
+    }
+
+    /**
+     * @return array
+     */
+    private function getStubDetailsData()
+    {
+        $data = [
+            'first_name' => 'foo',
+            'last_name'  => 'bar',
+            'birthday'   => Carbon::now()->subYears(25)->format('Y-m-d'),
+            'phone'      => '12345667',
+            'address'    => 'the address',
+            'country_id' => 688 //Serbia,
+        ];
+
+        return $data;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/RolesControllerTest.php b/tests/Feature/Http/Controllers/RolesControllerTest.php
new file mode 100644
index 0000000..fec51ef
--- /dev/null
+++ b/tests/Feature/Http/Controllers/RolesControllerTest.php
@@ -0,0 +1,134 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Tests\Feature\FunctionalTestCase;
+use Portal\Role;
+use Mockery as m;
+use Portal\User;
+
+class RolesControllerTest extends FunctionalTestCase
+{
+    protected $user;
+
+    protected $seed = false;
+
+    /**
+     * @before
+     */
+    public function setUp()
+    {
+        parent::setUp();
+        $this->user = $this->createSuperUser();
+        $this->be($this->user);
+    }
+
+    public function test_roles_list_is_displayed_properly()
+    {
+        $role1 = factory(Role::class)->create(['removable' => true]);
+        $role2 = factory(Role::class)->create(['removable' => false]);
+
+        $this->user->roles()->attach($role2->id);
+
+        $this->visit('role')
+            ->seeInTable('table', $role1->name, 1, 1)
+            ->seeInTable('table', $role1->display_name, 1, 2)
+            ->seeInTable('table', "0", 1, 3)
+            ->seeElement('table tbody tr:nth-child(1) > td a[title="Delete Role"]')
+            ->seeInTable('table', $role2->name, 2, 1)
+            ->seeInTable('table', $role2->display_name, 2, 2)
+            ->seeInTable('table', "1", 2, 3)
+            ->dontSeeElement('table tbody tr:nth-child(2) > td a[title="Delete Role"]');
+    }
+
+    public function test_create_role()
+    {
+        $data = $this->roleStubData();
+
+        $this->visit('role')
+            ->click('Add Role')
+            ->seePageIs('role/create')
+            ->submitForm('Create Role', $data);
+
+        $this->seePageIs('role')
+            ->see('Role created successfully.')
+            ->seeInDatabase('roles', $data);
+    }
+
+    public function test_edit_role()
+    {
+        $role = factory(Role::class)->create();
+
+        $this->visit('role')
+            ->clickOn('a[title="Edit Role"]')
+            ->seePageIs("role/{$role->id}/edit")
+            ->seeInField('name', $role->name)
+            ->seeInField('display_name', $role->display_name)
+            ->seeInField('description', $role->description);
+
+        $data = $this->roleStubData();
+
+        $this->submitForm('Update Role', $data)
+            ->seePageIs("role")
+            ->see('Role updated successfully.')
+            ->seeInDatabase('roles', $data + ['id' => $role->id]);
+    }
+
+    public function test_delete_role()
+    {
+        $this->artisan('db:seed', ['--class' => 'RolesSeeder']);
+
+        $role = factory(Role::class)->create(['removable' => true]);
+
+        $this->delete(route('role.delete', $role->id))
+            ->dontSeeInDatabase('roles', ['id' => $role->id]);
+    }
+
+    public function test_users_receive_default_role_after_their_role_is_deleted()
+    {
+        $this->artisan('db:seed', ['--class' => 'RolesSeeder']);
+
+        $user = factory(User::class)->create();
+        $role = factory(Role::class)->create(['removable' => true]);
+        $userRole = Role::where('name', 'User')->first();
+
+        $this->setRoleForUser($user, $role->name);
+
+        $this->assertTrue($user->hasRole($role->name));
+
+        $this->delete(route('role.delete', $role->id))
+            ->seeInDatabase('role_user', [
+                'role_id' => $userRole->id,
+                'user_id' => $user->id
+            ]);
+
+        $user = $user->fresh();
+
+        $this->assertFalse($user->hasRole($role->name));
+        $this->assertTrue($user->hasRole($userRole->name));
+    }
+
+    public function test_delete_unremovable_role()
+    {
+        $role = factory(Role::class)->create(['removable' => false]);
+
+        // This call should throw an exception
+        // because this role cannot be deleted
+        $this->delete(route('role.delete', $role->id));
+
+        $this->assertResponseStatus(404);
+        $this->see('Oops, 404!');
+    }
+
+    /**
+     * @return array
+     */
+    private function roleStubData()
+    {
+        return [
+            'name' => 'foo',
+            'display_name' => 'Foooooo',
+            'description' => 'the description'
+        ];
+    }
+}
diff --git a/tests/Feature/Http/Controllers/SettingsControllerTest.php b/tests/Feature/Http/Controllers/SettingsControllerTest.php
new file mode 100644
index 0000000..ea9b424
--- /dev/null
+++ b/tests/Feature/Http/Controllers/SettingsControllerTest.php
@@ -0,0 +1,34 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Settings;
+use Tests\Feature\FunctionalTestCase;
+
+class SettingsControllerTest extends FunctionalTestCase
+{
+    public function test_update_app_name()
+    {
+        $user = $this->createSuperUser();
+        $this->be($user);
+
+        $oldName = Settings::get('app_name', 'Portal');
+
+        Settings::set('app_name', 'bar');
+
+        $name = 'foo';
+
+        $this->visit('settings')
+            ->seeInField('app_name', 'bar')
+            ->type('foo', 'app_name')
+            ->press('Update Settings');
+
+        $this->assertEquals($name, Settings::get('app_name'));
+
+        $this->visit('logout')
+            ->seeInElement("#footer p", $name);
+
+        Settings::set('app_name', $oldName);
+        Settings::save();
+    }
+}
